﻿//Copyright (C) 2007-2024 Mariano Ortu <https://www.speedcrypt.info/>

using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;


namespace XMLConfig
{
    public partial class FrmInfo : Form
    {
        #region Constructors

        private FrmMain mainForm;
        public FrmInfo()
        {
            InitializeComponent();
        }
        public FrmInfo(Form callingForm)
        {
            mainForm = callingForm as FrmMain;
            InitializeComponent();
            loadAll();
        }

        #endregion Constructors

        #region Settings
        void loadAll()
        {
            //Form Settings
            Text = "Info...";
            MaximizeBox = false;
            MinimizeBox = false;
            FormBorderStyle = FormBorderStyle.FixedDialog;
            panel1.BackColor = Color.Gainsboro;

            //Linklabel
            linkLabSic.LinkClicked += LinkLabSic_LinkClicked;
            linkLabSpc.LinkClicked += LinkLabSpc_LinkClicked;
 
            //Button
            btnOk.Click += BtnOk_Click1;
        }
        #endregion Settings

        #region lLinklabels
        private void LinkLabSic_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start(linkLabSic.Text);
        }
        private void LinkLabSpc_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start(linkLabSpc.Text);
        }
        #endregion Linklabels

        #region Button
        private void BtnOk_Click1(object sender, System.EventArgs e)
        {
            Close();
        }
        #endregion Button
    }
}
