//Copyright (C) 2007-2024 Mariano Ortu <https://www.speedcrypt.info/>

using System;
using System.Collections;
using System.Xml;

namespace XMLConfig
{
	public class PrivateXmlConfig
	{
		protected ArrayList m_aFields = new ArrayList();
		protected ArrayList m_aValues = new ArrayList();

		public PrivateXmlConfig()
		{
		}
		public uint LoadFromFile(string strFile)
		{
			XmlDocument docConfig = new XmlDocument();
			XmlNode xmlField, xmlValue;
			string str;

			try { docConfig.Load(strFile); }
			catch(Exception) { return 1; }

			XmlElement el = docConfig.DocumentElement;
			if(el == null) return 2;
			if(el.Name != "Configuration") return 3;

			for(int i = 0; i < el.ChildNodes.Count; i++)
			{
				xmlField = el.ChildNodes[i].Attributes.GetNamedItem("Name");
				if(xmlField == null) continue;

				xmlValue = el.ChildNodes[i].Attributes.GetNamedItem("Value");

				str = xmlField.Value; m_aFields.Add(str);
				
				if(xmlValue != null) { str = xmlValue.Value; m_aValues.Add(str); }
				else { str = ""; m_aValues.Add(str); }
			}
			return 0;
		}
	
		public uint SaveToFile(string strFile)
		{
			XmlTextWriter xtw;

			try { xtw = new XmlTextWriter(strFile, null); }
			catch(Exception) { return 1; }

			if(xtw == null) return 2;

			xtw.WriteStartDocument();
			xtw.WriteWhitespace("\r\n");
			xtw.WriteStartElement("Configuration");
			xtw.WriteWhitespace("\r\n");

			for(int i = 0; i < m_aFields.Count; i++)
			{
				xtw.WriteWhitespace("\t");
				xtw.WriteStartElement("Key");
				xtw.WriteAttributeString("Name", (string)m_aFields[i]);
				xtw.WriteAttributeString("Value", (string)m_aValues[i]);
				xtw.WriteEndElement();
				xtw.WriteWhitespace("\r\n");
			}

			xtw.WriteEndElement();
			xtw.WriteWhitespace("\r\n");
			xtw.WriteEndDocument();
			xtw.Close();
		
			return 0;
		}

		public string GetValue(string strField)
		{
			for(int i = 0; i < m_aFields.Count; i++)
				if((string)m_aFields[i] == strField) return (string)m_aValues[i];

			return "";
		}
		
		public void SetValue(string strField, string strValue)
		{
			int iIndex = -1;

			for(int i = 0; i < m_aFields.Count; i++)
				if((string)m_aFields[i] == strField) { iIndex = i; break; }

			if(iIndex == -1)
			{
				m_aFields.Add(strField);
				m_aValues.Add(strValue);
			}
			else
			{
				m_aFields[iIndex] = strField;
				m_aValues[iIndex] = strValue;
			}
		}
	}
}
